﻿using Android;
using Android.App;
using Android.Content.PM;
using Android.OS;
using Android.Runtime;
using AndroidX.Core.App;
using AsReaderP252BAndroidDemo.Platforms.Android;

namespace AsReaderP252BAndroidDemo;

[Activity(Theme = "@style/Maui.SplashTheme", MainLauncher = true, ConfigurationChanges = ConfigChanges.ScreenSize | ConfigChanges.Orientation | ConfigChanges.UiMode | ConfigChanges.ScreenLayout | ConfigChanges.SmallestScreenSize | ConfigChanges.Density)]
public class MainActivity : MauiAppCompatActivity
{
    internal static MainActivity Instance { get; private set; }
    static readonly int REQUEST_TIRAMISU = 1000;
    static string[] PERMISSIONS_TIRAMISU = {
                Manifest.Permission.WakeLock,
                Manifest.Permission.ReadMediaImages,
                Manifest.Permission.ReadMediaVideo,
                Manifest.Permission.BluetoothAdmin,
                Manifest.Permission.BluetoothScan,
                Manifest.Permission.BluetoothConnect,
                Manifest.Permission.AccessFineLocation,
                Manifest.Permission.AccessCoarseLocation
        };
    static readonly int REQUEST_S = 2000;
    static string[] PERMISSIONS_S = {
                Manifest.Permission.WakeLock,
                Manifest.Permission.ReadExternalStorage,
                Manifest.Permission.WriteExternalStorage,
                Manifest.Permission.BluetoothAdmin,
                Manifest.Permission.BluetoothScan,
                Manifest.Permission.BluetoothConnect,
                Manifest.Permission.AccessFineLocation,
                Manifest.Permission.AccessCoarseLocation
        };
    static readonly int REQUEST = 3000;
    static string[] PERMISSIONS = {
                Manifest.Permission.WakeLock,
                Manifest.Permission.ReadExternalStorage,
                Manifest.Permission.WriteExternalStorage,
                Manifest.Permission.BluetoothAdmin,
                Manifest.Permission.AccessFineLocation,
                Manifest.Permission.AccessCoarseLocation
        };
    protected override void OnCreate(Bundle savedInstanceState)
    {
        base.OnCreate(savedInstanceState);
        Instance = this;
        CheckPermission();
    }
    protected override void OnDestroy()
    {
        base.OnDestroy();
        AsReaderP252BMAUIManager manager = AsReaderP252BMAUIManager.sharedInstance();
        manager.Destroy();
    }
    public override void OnRequestPermissionsResult(int requestCode, string[] permissions, [GeneratedEnum] Android.Content.PM.Permission[] grantResults)
    {
        if (requestCode == REQUEST_TIRAMISU)
        {
            bool status = true;
            for (int i = 0; i < grantResults.Length; i++)
            {
                if (grantResults[i] == Permission.Denied)
                {
                    status = false;
                    break;
                }
            }
            if (status == true)
            {
                initAsReaderManager();
            }
        }
        else if (requestCode == REQUEST_S)
        {
            bool status = true;
            for (int i = 0; i < grantResults.Length; i++)
            {
                if (grantResults[i] == Permission.Denied)
                {
                    status = false;
                    break;
                }
            }
            if (status == true)
            {
                initAsReaderManager();
            }
        }
        else if (requestCode == REQUEST)
        {
            bool status = true;
            for (int i = 0; i < grantResults.Length; i++)
            {
                if (grantResults[i] == Permission.Denied)
                {
                    status = false;
                    break;
                }
            }
            if (status == true)
            {
                initAsReaderManager();
            }
        }
    }
    private void CheckPermission()
    {
        if (Build.VERSION.SdkInt >= BuildVersionCodes.Tiramisu)
        {
            if (ActivityCompat.CheckSelfPermission(this, Manifest.Permission.WakeLock) != (int)Permission.Granted
            || ActivityCompat.CheckSelfPermission(this, Manifest.Permission.ReadMediaImages) != (int)Permission.Granted
            || ActivityCompat.CheckSelfPermission(this, Manifest.Permission.ReadMediaVideo) != (int)Permission.Granted
            || ActivityCompat.CheckSelfPermission(this, Manifest.Permission.BluetoothAdmin) != (int)Permission.Granted
            || ActivityCompat.CheckSelfPermission(this, Manifest.Permission.BluetoothScan) != (int)Permission.Granted
            || ActivityCompat.CheckSelfPermission(this, Manifest.Permission.BluetoothConnect) != (int)Permission.Granted
            || ActivityCompat.CheckSelfPermission(this, Manifest.Permission.AccessFineLocation) != (int)Permission.Granted
            || ActivityCompat.CheckSelfPermission(this, Manifest.Permission.AccessCoarseLocation) != (int)Permission.Granted)
            {
                ActivityCompat.RequestPermissions(this, PERMISSIONS_TIRAMISU, REQUEST_TIRAMISU);
            } else
            {
                initAsReaderManager();
            }
        }
        else if (Build.VERSION.SdkInt >= BuildVersionCodes.S)
        {
            if (ActivityCompat.CheckSelfPermission(this, Manifest.Permission.WakeLock) != (int)Permission.Granted
            || ActivityCompat.CheckSelfPermission(this, Manifest.Permission.ReadExternalStorage) != (int)Permission.Granted
            || ActivityCompat.CheckSelfPermission(this, Manifest.Permission.WriteExternalStorage) != (int)Permission.Granted
            || ActivityCompat.CheckSelfPermission(this, Manifest.Permission.BluetoothAdmin) != (int)Permission.Granted
            || ActivityCompat.CheckSelfPermission(this, Manifest.Permission.BluetoothScan) != (int)Permission.Granted
            || ActivityCompat.CheckSelfPermission(this, Manifest.Permission.BluetoothConnect) != (int)Permission.Granted
            || ActivityCompat.CheckSelfPermission(this, Manifest.Permission.AccessFineLocation) != (int)Permission.Granted
            || ActivityCompat.CheckSelfPermission(this, Manifest.Permission.AccessCoarseLocation) != (int)Permission.Granted)
            {
                ActivityCompat.RequestPermissions(this, PERMISSIONS_S, REQUEST_S);
            }
            else
            {
                initAsReaderManager();
            }
        }
        else
        {
            if (ActivityCompat.CheckSelfPermission(this, Manifest.Permission.WakeLock) != (int)Permission.Granted
            || ActivityCompat.CheckSelfPermission(this, Manifest.Permission.ReadExternalStorage) != (int)Permission.Granted
            || ActivityCompat.CheckSelfPermission(this, Manifest.Permission.WriteExternalStorage) != (int)Permission.Granted
            || ActivityCompat.CheckSelfPermission(this, Manifest.Permission.BluetoothAdmin) != (int)Permission.Granted
            || ActivityCompat.CheckSelfPermission(this, Manifest.Permission.AccessFineLocation) != (int)Permission.Granted
            || ActivityCompat.CheckSelfPermission(this, Manifest.Permission.AccessCoarseLocation) != (int)Permission.Granted)
            {
                ActivityCompat.RequestPermissions(this, PERMISSIONS, REQUEST);
            }
            else
            {
                initAsReaderManager();
            }
        }
    }
    private void initAsReaderManager()
    {
        AsReaderP252BMAUIManager manager = AsReaderP252BMAUIManager.sharedInstance();
        manager.SetContext();
    }
}
